<?php
// +--------------------------------------------------------------------------+
// | Contentteller(R) 2.1.17 Update #2                                        |
// +--------------------------------------------------------------------------+
// | Copyright (C) 2002 - 2013 by Esselbach Internet Solutions                |
// | Available from http://www.contentteller.com                              |
// +--------------------------------------------------------------------------+
// | Contentteller is not free software. You may not redistribute this file   |
// | or its derivatives without written permission.                           |
// +--------------------------------------------------------------------------+
// | Contentteller is a registered trademark.                                 |
// +--------------------------------------------------------------------------+
// | Build: 824.98.131123-190401                                              |
// +--------------------------------------------------------------------------+

/**
 * @package Contentteller
 * @subpackage Core
 * @copyright (C) 2002-2013 Esselbach Internet Solutions
 */

/**
 * function AdminConvertToUTF8
 * A function to convert an existing database to UTF-8 encoding
 * @author Philipp Louis Esselbach
 */
function AdminConvertToUTF8( $opts )
{
	global $database, $html, $system, $security, $preferences, $words_core, $config;
	$security_hash = $system -> adminhashput();
	$html -> makeheader( $words_core[ 'CONVERT_TO_UTF8' ] );

	$html -> makesubheader();
	$html -> makegroupmenu( "core" );
	$html -> makemainheader( $words_core[ 'CONVERT_TO_UTF8' ], "convertutf8" );

	$opts = ( isset( $opts ) ) ? $security -> checknum( $opts ) : 0 ;

	if( !$preferences[ 'product_demo' ] )
	{
		if( $config[ 'DB_COLLATION' ] != "UTF-8" )
		{
		    if( !$opts )
		    {
		        echo $words_core[ 'INTRO_CONVERT' ] . "<br /><br /><a href=\"index.php?action=converttoutf8&amp;opts=1\">" . $words_core[ 'CLICK_HERE' ] . "</a> " . $words_core[ 'TO_START_THE_CONVERTER' ] . "<br />";
		    }
		    else
		    {
		        @set_time_limit( 0 );
		        $tables = array();
		        $query = $database -> dbquery( "SHOW TABLES" );
		        while( list( $table ) = $database -> dbrow( $query ) )
		        {
		            if( preg_match( "/esselbach_ct/i", $table ) )
		            {
		                $tables[] = $table;
		            }
		        }

		        $ctable = $opts - 1;
		        $ntable = $opts + 1;

		        if( $opts == 1 )
		        {
		            $database -> dbquery( "ALTER DATABASE " . $config[ 'DB_DATABASE' ] . " DEFAULT CHARACTER SET utf8 COLLATE utf8_general_ci" );
		        }

		        if( $opts <= count($tables ) )
		        {
		            echo $words_core[ 'CONVERTING_TABLE' ] . " " . $tables[ $ctable ] . " (" . $opts . "/" . count( $tables ) . ")";
		            $database -> dbquery( "ALTER TABLE " . $tables[ $ctable ] . " CONVERT TO CHARACTER SET utf8 COLLATE utf8_general_ci" );

		            if( !preg_match( "/online/i", $tables[ $ctable ] ) )
		            {
		                $database -> dbquery( "ALTER TABLE " . $tables[ $ctable ] . " ENGINE = InnoDB" );
		            }
		            $html -> jump( "index.php?action=converttoutf8&opts=" . $ntable, 1000 );
		        }
		        else
		        {
		            $database -> dbquery( "UPDATE " . DB_PREFIX . "esselbach_ct_preferences SET preference_value = 'UTF-8' WHERE preference_key = 'WEBSITE_CHARSET'" );
                    if( $file = @fopen( "../includes/config.php", w ) )
	                {
                		if( flock( $file, 2 ) )
                		{
                			fputs( $file, "<?php\n\n\$config['DB_HOSTNAME'] = \"" . $config[ 'DB_HOSTNAME' ] . "\";\n\$config['DB_USERNAME'] = \"" . $config[ 'DB_USERNAME' ] . "\";\n\$config['DB_PASSWORD'] = \"" . $config[ 'DB_PASSWORD' ] . "\";\n\$config['DB_DATABASE'] = \"" . $config[ 'DB_DATABASE' ] . "\";\n\$config['DB_LAYER'] = \"" . $config[ 'DB_LAYER' ] . "\";\n\$config['DB_PREFIX'] = \"" . $config[ 'DB_PREFIX' ] . "\";\n\$config['DB_ENGINE'] = \"InnoDB\";\n\$config['DB_COLLATION'] = \"UTF-8\";\n\$config['WEBSITE'] = \"" . $config[ 'WEBSITE' ] . "\";\n\$config['MAIN_MODULE'] = \"" . $config[ 'MAIN_MODULE' ] . "\";\n\$config['DEFAULT_THEME'] = \"" . $config[ 'DEFAULT_THEME' ] . "\";\n\$config['ADMIN_LANGUAGE'] = \"" . $config[ 'ADMIN_LANGUAGE' ] . "\";\n\$config['INSTALL_CHARSET'] = \"" . $config[ 'INSTALL_CHARSET' ] . "\";\n\$config['CACHE_PREFERENCES'] = \"" . $config[ 'CACHE_PREFERENCES' ] . "\";\n\n?>" );
                		}

                		flock( $file, 3 );
                		fclose( $file );
	                }
		            echo $words_core[ 'DATABASE_SUCCESSFULLY_CONVERTED' ];
		        }


		    }
		}
		else
		{
		    echo $words_core[ 'YOUR_DATABASE_IS_ALREADY_CONVERTED' ];
		}
	}
	else
	{
		echo $words_core[ 'DEMO_NA' ] . "</div>";
	}

	$html -> makeformfooter();
}
?>